/**
 *
 * $Id: oint.c,v 1.2 1999/04/15 12:15:27 isizaka Exp $
 *
 * Copyright (C) 1997, Satoshi ISHIZAKA.
 *
 * This file is part of Ngraph.
 *
 * This is free software; you can redistribute it and/or modify it.
 * However, it is prohibited to compile this on the "Windows" environment.
 *
 * Original author: Satoshi ISHIZAKA
 *                  isizaka@msa.biglobe.ne.jp
 **/

/**
 *
 * $Log: oint.c,v $
 * Revision 1.2  1999/04/15 12:15:27  isizaka
 * for release 6.03.01
 *
 * Revision 1.1  1999/03/17 13:46:09  isizaka
 * Initial revision
 *
 *
 **/

#include <stdlib.h>
#include <ctype.h>
#include "ngraph.h"
#include "object.h"

#define NAME "int"
#define PARENT "object"
#define VERSION "1.00.00"
#define TRUE  1
#define FALSE 0

#define ERRILNAME 100

#define ERRNUM 1

char *interrorlist[ERRNUM]={
""
};

int intinit(struct objlist *obj,char *inst,char *rval,int argc,char **argv)
{
  if (_exeparent(obj,(char *)argv[1],inst,rval,argc,argv)) return 1;
  return 0;
}

int intdone(struct objlist *obj,char *inst,char *rval,int argc,char **argv)
{
  if (_exeparent(obj,(char *)argv[1],inst,rval,argc,argv)) return 1;
  return 0;
}

#define TBLNUM 4

struct objtable oint[TBLNUM] = {
  {"init",NVFUNC,NEXEC,intinit,NULL,0},
  {"done",NVFUNC,NEXEC,intdone,NULL,0},
  {"next",NPOINTER,0,NULL,NULL,0},
  {"@",NINT,NREAD|NWRITE,NULL,NULL,0},
};

void *addint()
{
  return addobject(NAME,NULL,PARENT,VERSION,TBLNUM,oint,ERRNUM,interrorlist,NULL,NULL);
}
